---
product: "AG Grid"
title: "Grid Layout"
description: "Format the grid layout for your JavaScript Table. Change grid width/height, assign a DOM layout value, format dynamic resizing."
framework: javascript
version: "36.2.0"
related:
    - title: "Design System"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/ag-grid-design-system/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Layout

Set the width, height and scrolling behaviour of the grid.

```html
<!-- set width using percentages -->
<div id="myGrid" style="width: 100%; height: 100%;"></div>

<!-- OR set width using fixed pixels -->
<div id="myGrid" style="width: 500px; height: 200px;"></div>
```

> **Warning**
>
> If using % for your height, then make sure the container you are putting the grid into also has height specified, as the browser will fit the div according to a percentage of the parent's height, and if the parent has no height, then this % will always be zero.
>
> If your grid is not the size you think it should be then put a border on the grid's div and see if that's the size you want (the grid will fill this div). If it is not the size you want, then you have a CSS layout issue in your application.

## DOM Layout

There are three DOM Layout values the grid can have 'normal', 'autoHeight' and 'print'. They are used as follows:

- **normal**: This is the default if nothing is specified. The grid fits the width and height of the div you provide and scrolls in both directions.
- **autoHeight**: The grid's height adjusts to fit the number of rows, with optional minimum and maximum height.
- **print**: No scroll bars are used and the grid renders all rows and columns. This layout is explained in [Printing](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/printing/).

## Normal Layout

If the width and / or height change after the grid is initialised, the grid will automatically resize to fill the new area.

The example below shows setting the grid size and then changing it as the user selects the buttons.

#### Width & Height

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

let gridApi: GridApi<IOlympicData>;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", width: 150 },
    { field: "age", width: 90 },
    { field: "country", width: 150 },
    { field: "year", width: 90 },
    { field: "date", width: 150 },
    { field: "sport", width: 150 },
    { field: "gold", width: 100 },
    { field: "silver", width: 100 },
    { field: "bronze", width: 100 },
    { field: "total", width: 100 },
  ],
};

function fillLarge() {
  setWidthAndHeight("100%");
}

function fillMedium() {
  setWidthAndHeight("60%");
}

function fillExact() {
  setWidthAndHeight("400px");
}

function setWidthAndHeight(size: string) {
  const eGridDiv = document.querySelector<HTMLElement>("#myGrid")! as any;
  eGridDiv.style.setProperty("width", size);
  eGridDiv.style.setProperty("height", size);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).fillLarge = fillLarge;
  (<any>window).fillMedium = fillMedium;
  (<any>window).fillExact = fillExact;
}
```

[Live example: Width & Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/width-and-height/typescript/)

### Dynamic Resizing without Horizontal Scroll

Sometimes you want to have columns that don't fit in the current viewport to simply be hidden altogether with no horizontal scrollbar.

To achieve this determine the width of the grid and work out how many columns could fit in that space, hiding any that don't fit, constantly updating based on the `gridSizeChanged` event firing, like the next example shows.

This example is best seen when opened in a new tab - then change the horizontal size of the browser and watch as columns hide/show based on the current grid size.

#### Dynamic horizontal resizing without scroll

```ts
import {
  ClientSideRowModelModule,
  ColumnApiModule,
  ColumnAutoSizeModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridSizeChangedEvent,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnAutoSizeModule,
  ColumnApiModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi<IOlympicData>;
let sizeToFitTimer: number | undefined;

const gridOptions: GridOptions<IOlympicData> = {
  columnDefs: [
    { field: "athlete", minWidth: 150 },
    { field: "age", minWidth: 70, maxWidth: 90 },
    { field: "country", minWidth: 130 },
    { field: "year", minWidth: 70, maxWidth: 90 },
    { field: "date", minWidth: 120 },
    { field: "sport", minWidth: 120 },
    { field: "gold", minWidth: 80 },
    { field: "silver", minWidth: 80 },
    { field: "bronze", minWidth: 80 },
    { field: "total", minWidth: 80 },
  ],
  onGridSizeChanged: onGridSizeChanged,
  onFirstDataRendered: onFirstDataRendered,
};

function onGridSizeChanged(params: GridSizeChangedEvent) {
  // get the current grids width
  const gridWidth = document.querySelector(".ag-grid-viewport")!.clientWidth;

  // keep track of which columns to hide/show
  const columnsToShow = [];
  const columnsToHide = [];

  // iterate over all columns (visible or not) in their current displayed order,
  // so that hiding follows the order the user sees rather than the column definition order
  let totalColsWidth = 0;
  const allColumns = params.api.getAllGridColumns();
  for (let i = 0, len = allColumns.length; i < len; i++) {
    const column = allColumns[i];
    totalColsWidth += column.getMinWidth();
    if (totalColsWidth > gridWidth) {
      columnsToHide.push(column.getColId());
    } else {
      columnsToShow.push(column.getColId());
    }
  }

  // show/hide columns based on current grid width
  params.api.setColumnsVisible(columnsToShow, true);
  params.api.setColumnsVisible(columnsToHide, false);

  // wait until columns stopped moving and fill out
  // any available space to ensure there are no gaps. The timer is cleared on every size change so
  // only the latest one re-fits, and the grid can be destroyed before it fires - hence the guard.
  window.clearTimeout(sizeToFitTimer);
  sizeToFitTimer = window.setTimeout(() => {
    if (params.api.isDestroyed()) {
      return;
    }
    params.api.sizeColumnsToFit();
  }, 10);
}

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  params.api.sizeColumnsToFit();
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Dynamic horizontal resizing without scroll](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example1/typescript/)

### Dynamic Vertical Resizing

Sometimes the grid is taller than the rows it contains. You can dynamically set the row heights to fill the available height as the following example shows:

#### Dynamic vertical resizing

```ts
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridSizeChangedEvent,
  ModuleRegistry,
  RenderApiModule,
  RowApiModule,
  RowHeightParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RenderApiModule,
  RowApiModule,
  ClientSideRowModelModule,
]);

let minRowHeight = 25;
let currentRowHeight: number;

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "athlete", width: 140 },
    { field: "age", width: 60 },
    { field: "country", width: 130 },
    { field: "year", width: 70 },
    { field: "date", width: 110 },
    { field: "sport", width: 110 },
    { field: "gold", flex: 1 },
    { field: "silver", flex: 1 },
    { field: "bronze", flex: 1 },
    { field: "total", flex: 1 },
  ],

  rowData: getData(),
  onGridReady: (params: GridReadyEvent) => {
    minRowHeight = params.api.getSizesForCurrentTheme().rowHeight;
    currentRowHeight = minRowHeight;
  },
  onFirstDataRendered: onFirstDataRendered,
  onGridSizeChanged: onGridSizeChanged,
  getRowHeight: (params: RowHeightParams) => {
    return currentRowHeight;
  },
};

function onFirstDataRendered(params: FirstDataRenderedEvent) {
  updateRowHeight(params);
}

function onGridSizeChanged(params: GridSizeChangedEvent) {
  updateRowHeight(params);
}

const updateRowHeight = (params: { api: GridApi }) => {
  // get the height of the grid body - this excludes the height of the headers
  const gridViewport = document.querySelector<HTMLElement>(".ag-grid-viewport");
  const topRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-top-rows",
  );
  const bottomRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-bottom-rows",
  );

  if (!gridViewport) {
    return;
  }

  const gridHeight =
    gridViewport.clientHeight -
    (topRows?.clientHeight ?? 0) -
    (bottomRows?.clientHeight ?? 0);
  // get the rendered rows
  const renderedRowCount = params.api.getDisplayedRowCount();
  if (renderedRowCount === 0) {
    return;
  }

  // if the rendered rows * min height is greater than available height, just set the height
  // to the min and let the scrollbar do its thing
  if (renderedRowCount * minRowHeight >= gridHeight) {
    if (currentRowHeight !== minRowHeight) {
      currentRowHeight = minRowHeight;
      params.api.resetRowHeights();
    }
  } else {
    // set the height of the row to the grid height / number of rows available
    currentRowHeight = Math.floor(gridHeight / renderedRowCount);
    params.api.resetRowHeights();
  }
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
```

[Live example: Dynamic vertical resizing](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example2/typescript/)

## Auto Height Layout

Depending on your scenario, you may wish for the grid to auto-size it's height to the number of rows displayed inside the grid. This is useful if you have relatively few rows and don't want empty space between the last row and the bottom of the grid.

To allow the grid to auto-size its height to fit rows, set grid property `domLayout='autoHeight'`.

When `domLayout='autoHeight'` then your application **should not** set height on the grid div, as the div should be allowed flow naturally to fit the grid contents. When auto height is off then your application **should** set height on the grid div, as the grid will fill the div you provide it.

> **Warning**
>
> There is no default maximum height, which means that the grid will render all rows. When using the Server-Side Row Model, this will mean loading the entire data set. For large grids (eg >1,000 rows) the draw time of the grid will be slow, or for very large grids, your application can freeze. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display on one web page. For this reason, if showing large amounts of data, set a [max height](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grid-size/#minimum-and-maximum-height-with-auto-height) to limit the number of rows rendered.

The example below demonstrates the autoHeight feature. Notice the following:

- As you set different numbers of rows into the grid, the grid will resize its height to just fit the rows.
- As the grid height exceeds the height of the browser, you will need to use the browser vertical scroll to view data (or the iFrames scroll if you are looking at the example embedded below).
- The height will also adjust as you filter, to add and remove rows.
- If you have pinned rows, the grid will size to accommodate the pinned rows.
- Vertical scrolling will not happen, however horizontal scrolling, including pinned columns, will work as normal.
- You can switch the grid into and out of auto-height mode by calling `api.setGridOption('domLayout', layout)` or by changing the bound `domLayout` property.

> **Note**
>
> The following example is best viewed in a new tab, so it is obvious that there are no scroll bars. When viewed inline below, the scroll bars shown are for the containing iframe, not the grid.

#### Auto Height

```ts
import {
  ClientSideRowModelModule,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  NumberFilterModule,
  PinnedRowModule,
  TextFilterModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  NumberFilterModule,
]);

const columnDefs: ColGroupDef[] = [
  {
    headerName: "Core",
    children: [
      { headerName: "ID", field: "id" },
      { field: "make" },
      { field: "price", filter: "agNumberColumnFilter" },
    ],
  },
  {
    headerName: "Extra",
    children: [
      { field: "val1", filter: "agNumberColumnFilter" },
      { field: "val2", filter: "agNumberColumnFilter" },
      { field: "val3", filter: "agNumberColumnFilter" },
      { field: "val4", filter: "agNumberColumnFilter" },
      { field: "val5", filter: "agNumberColumnFilter" },
      { field: "val6", filter: "agNumberColumnFilter" },
      { field: "val7", filter: "agNumberColumnFilter" },
      { field: "val8", filter: "agNumberColumnFilter" },
      { field: "val9", filter: "agNumberColumnFilter" },
      { field: "val10", filter: "agNumberColumnFilter" },
    ],
  },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  defaultColDef: {
    enableRowGroup: true,
    enableValue: true,
    filter: true,
  },
  rowData: getData(5),
  domLayout: "autoHeight",
  onGridReady: (params) => {
    document.querySelector("#currentRowCount")!.textContent = "5";
  },
  popupParent: document.body,
};

function createRow(index: number) {
  const makes = ["Toyota", "Ford", "BMW", "Phantom", "Porsche"];

  return {
    id: "D" + (1000 + index),
    make: makes[Math.floor(window.agRandom() * makes.length)],
    price: Math.floor(window.agRandom() * 100000),
    val1: Math.floor(window.agRandom() * 1000),
    val2: Math.floor(window.agRandom() * 1000),
    val3: Math.floor(window.agRandom() * 1000),
    val4: Math.floor(window.agRandom() * 1000),
    val5: Math.floor(window.agRandom() * 1000),
    val6: Math.floor(window.agRandom() * 1000),
    val7: Math.floor(window.agRandom() * 1000),
    val8: Math.floor(window.agRandom() * 1000),
    val9: Math.floor(window.agRandom() * 1000),
    val10: Math.floor(window.agRandom() * 1000),
  };
}

function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push(createRow(i));
  }
  return rowData;
}

function updateRowData(rowCount: number) {
  gridApi!.setGridOption("rowData", getData(rowCount));

  document.querySelector("#currentRowCount")!.textContent = `${rowCount}`;
}

function toggleFloatingRows() {
  const show = (document.getElementById("floating-rows") as HTMLInputElement)
    .checked;
  if (show) {
    gridApi!.setGridOption("pinnedTopRowData", [
      createRow(999),
      createRow(998),
    ]);
    gridApi!.setGridOption("pinnedBottomRowData", [
      createRow(997),
      createRow(996),
    ]);
  } else {
    gridApi!.setGridOption("pinnedTopRowData", undefined);
    gridApi!.setGridOption("pinnedBottomRowData", undefined);
  }
}

function setDomLayoutAutoHeight() {
  gridApi!.setGridOption("domLayout", "autoHeight");
  // auto height will get the grid to fill the height of the contents,
  // so the grid div should have no height set, the height is dynamic.
  (document.querySelector<HTMLElement>("#myGrid")! as any).style.height = "";
}

function setDomLayoutNormal() {
  gridApi!.setGridOption("domLayout", "normal");
  // when auto height is off, the grid has a fixed height and provides
  // scrollbars if the data does not fit into it.
  (document.querySelector<HTMLElement>("#myGrid")! as any)!.style.height =
    "400px";
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).updateRowData = updateRowData;
  (<any>window).toggleFloatingRows = toggleFloatingRows;
  (<any>window).setDomLayoutAutoHeight = setDomLayoutAutoHeight;
  (<any>window).setDomLayoutNormal = setDomLayoutNormal;
}
```

[Live example: Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height/typescript/)

### Minimum and Maximum Height with Auto Height

You can constrain the height of the grid body - the scrolling rows, excluding headers and pinned rows. By default the minimum height is 150px (because a zero-height grid looks weird) and there is no maximum height. This can be customised using two [theme parameters](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/theming-parameters/):

```js
const myTheme = themeQuartz.withParams({
    autoHeightMinBodyHeight: 0,
    autoHeightMaxBodyHeight: 400,
});
```

Once the height of the available rows exceeds the maximum height, the grid stops growing and scrolls instead, using [virtualisation](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/dom-virtualisation/) to ensure that large datasets are rendered efficiently.

You can see the effect of minimum and maximum heights with different numbers of rows in the following example:

#### Max Height with Auto Height

```ts
import {
  ClientSideRowModelModule,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

let rowCount = 5;
let minBodyHeight = 100;
let maxBodyHeight: number | "none" = 250;

function buildTheme() {
  return themeQuartz.withParams({
    autoHeightMinBodyHeight: minBodyHeight,
    autoHeightMaxBodyHeight: maxBodyHeight,
  });
}

const makes = ["Toyota", "Ford", "BMW", "Porsche", "Audi"];

function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push({
      id: "D" + (1000 + i),
      make: makes[i % makes.length],
      model: "Model " + (i + 1),
      price: 20000 + i * 750,
    });
  }
  return rowData;
}

const gridOptions: GridOptions = {
  theme: buildTheme(),
  domLayout: "autoHeight",
  columnDefs: [
    { field: "id" },
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ],
  defaultColDef: {
    flex: 1,
  },
  rowData: getData(rowCount),
};

const gridApi = createGrid(
  document.querySelector<HTMLElement>("#myGrid")!,
  gridOptions,
);

function onRowCountChanged() {
  rowCount = Number(
    (document.getElementById("row-count") as HTMLInputElement).value,
  );
  gridApi.setGridOption("rowData", getData(rowCount));
}

function onMinBodyHeightChanged() {
  minBodyHeight = Number(
    (document.getElementById("min-body-height") as HTMLInputElement).value,
  );
  gridApi.setGridOption("theme", buildTheme());
}

function onMaxBodyHeightChanged() {
  const value = (document.getElementById("max-body-height") as HTMLInputElement)
    .value;
  // an empty control means no maximum, the default for auto height
  maxBodyHeight = value === "" ? "none" : Number(value);
  gridApi.setGridOption("theme", buildTheme());
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onRowCountChanged = onRowCountChanged;
  (<any>window).onMinBodyHeightChanged = onMinBodyHeightChanged;
  (<any>window).onMaxBodyHeightChanged = onMaxBodyHeightChanged;
}
```

[Live example: Max Height with Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height-max/typescript/)

## Print Layout

For details on displaying the grid in a printer friendly layout see the [Print Layout](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/printing/) page.


---
product: "AG Grid"
title: "Grid Layout"
description: "Format the grid layout for your Vue Table. Change grid width/height, assign a DOM layout value, format dynamic resizing."
framework: vue
version: "36.2.0"
related:
    - title: "Design System"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/ag-grid-design-system/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Layout

Set the width, height and scrolling behaviour of the grid.

```html
<!-- set width using percentages -->
<ag-grid-vue style="width: 100%; height: 100%;"></ag-grid-vue>

<!-- OR set width using fixed pixels -->
<ag-grid-vue style="width: 500px; height: 200px"></ag-grid-vue>
```

> **Warning**
>
> If using % for your height, then make sure the container you are putting the grid into also has height specified, as the browser will fit the div according to a percentage of the parent's height, and if the parent has no height, then this % will always be zero.
>
> If your grid is not the size you think it should be then put a border on the grid's div and see if that's the size you want (the grid will fill this div). If it is not the size you want, then you have a CSS layout issue in your application.

## DOM Layout

There are three DOM Layout values the grid can have 'normal', 'autoHeight' and 'print'. They are used as follows:

- **normal**: This is the default if nothing is specified. The grid fits the width and height of the div you provide and scrolls in both directions.
- **autoHeight**: The grid's height adjusts to fit the number of rows, with optional minimum and maximum height.
- **print**: No scroll bars are used and the grid renders all rows and columns. This layout is explained in [Printing](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/printing/).

## Normal Layout

If the width and / or height change after the grid is initialised, the grid will automatically resize to fill the new area.

The example below shows setting the grid size and then changing it as the user selects the buttons.

#### Width & Height

```ts
import { createApp } from "vue";

import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridVue } from "ag-grid-vue3";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

const VueExample = {
  template: `
        <div style="display: flex; flex-direction: column; height: 100%">
            <div style="margin-bottom: 5px;">
                <button @click="fillLarge">Fill 100%</button>
                <button @click="fillMedium">Fill 60%</button>
                <button @click="fillExact">Exactly 400 x 400 pixels</button>
            </div>
            <div style="width: 100%; flex: 1 1 auto;">
                <ag-grid-vue :style="{width, height}"
                             @grid-ready="onGridReady"
                             :columnDefs="columnDefs"
                             :rowData="rowData"
                             ></ag-grid-vue>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data: function () {
    return {
      columnDefs: null,
      rowData: null,
      height: "100%",
      width: "100%",
    };
  },
  beforeMount() {
    this.columnDefs = <ColDef[]>[
      { field: "athlete", width: 150 },
      { field: "age", width: 90 },
      { field: "country", width: 150 },
      { field: "year", width: 90 },
      { field: "date", width: 150 },
      { field: "sport", width: 150 },
      { field: "gold", width: 100 },
      { field: "silver", width: 100 },
      { field: "bronze", width: 100 },
      { field: "total", width: 100 },
    ];
  },
  methods: {
    fillLarge() {
      this.setWidthAndHeight("100%", "100%");
    },
    fillMedium() {
      this.setWidthAndHeight("60%", "60%");
    },
    fillExact() {
      this.setWidthAndHeight("400px", "400px");
    },
    setWidthAndHeight(width, height) {
      this.width = width;
      this.height = height;
    },
    onGridReady(params: GridReadyEvent) {
      const updateData = (data) => (this.rowData = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    },
  },
};

createApp(VueExample).mount("#app");
```

[Live example: Width & Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/width-and-height/vue3/)

### Dynamic Resizing without Horizontal Scroll

Sometimes you want to have columns that don't fit in the current viewport to simply be hidden altogether with no horizontal scrollbar.

To achieve this determine the width of the grid and work out how many columns could fit in that space, hiding any that don't fit, constantly updating based on the `gridSizeChanged` event firing, like the next example shows.

This example is best seen when opened in a new tab - then change the horizontal size of the browser and watch as columns hide/show based on the current grid size.

#### Dynamic horizontal resizing without scroll

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  ColumnAutoSizeModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridSizeChangedEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnAutoSizeModule,
  ColumnApiModule,
  ClientSideRowModelModule,
]);

let sizeToFitTimer: number | undefined;

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div id="grid-wrapper" style="width: 100%; height: 100%">
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :rowData="rowData"
        @grid-size-changed="onGridSizeChanged"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", minWidth: 150 },
      { field: "age", minWidth: 70, maxWidth: 90 },
      { field: "country", minWidth: 130 },
      { field: "year", minWidth: 70, maxWidth: 90 },
      { field: "date", minWidth: 120 },
      { field: "sport", minWidth: 120 },
      { field: "gold", minWidth: 80 },
      { field: "silver", minWidth: 80 },
      { field: "bronze", minWidth: 80 },
      { field: "total", minWidth: 80 },
    ]);
    const rowData = ref<IOlympicData[]>(null);

    function onGridSizeChanged(params: GridSizeChangedEvent) {
      // get the current grids width
      const gridWidth =
        document.querySelector(".ag-grid-viewport")!.clientWidth;
      // keep track of which columns to hide/show
      const columnsToShow = [];
      const columnsToHide = [];
      // iterate over all columns (visible or not) in their current displayed order,
      // so that hiding follows the order the user sees rather than the column definition order
      let totalColsWidth = 0;
      const allColumns = params.api.getAllGridColumns();
      for (let i = 0, len = allColumns.length; i < len; i++) {
        const column = allColumns[i];
        totalColsWidth += column.getMinWidth();
        if (totalColsWidth > gridWidth) {
          columnsToHide.push(column.getColId());
        } else {
          columnsToShow.push(column.getColId());
        }
      }
      // show/hide columns based on current grid width
      params.api.setColumnsVisible(columnsToShow, true);
      params.api.setColumnsVisible(columnsToHide, false);
      // wait until columns stopped moving and fill out
      // any available space to ensure there are no gaps. The timer is cleared on every size change so
      // only the latest one re-fits, and the grid can be destroyed before it fires - hence the guard.
      window.clearTimeout(sizeToFitTimer);
      sizeToFitTimer = window.setTimeout(() => {
        if (params.api.isDestroyed()) {
          return;
        }
        params.api.sizeColumnsToFit();
      }, 10);
    }
    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      params.api.sizeColumnsToFit();
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      const updateData = (data) => (rowData.value = data);

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => updateData(data));
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      onGridReady,
      onGridSizeChanged,
      onFirstDataRendered,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Dynamic horizontal resizing without scroll](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example1/vue3/)

### Dynamic Vertical Resizing

Sometimes the grid is taller than the rows it contains. You can dynamically set the row heights to fill the available height as the following example shows:

#### Dynamic vertical resizing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GetRowHeight,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridSizeChangedEvent,
  ModuleRegistry,
  RenderApiModule,
  RowApiModule,
  RowHeightParams,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RenderApiModule,
  RowApiModule,
  ClientSideRowModelModule,
]);

let minRowHeight = 25;

let currentRowHeight: number;

const updateRowHeight = (params: { api: GridApi }) => {
  // get the height of the grid body - this excludes the height of the headers
  const gridViewport = document.querySelector<HTMLElement>(".ag-grid-viewport");
  const topRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-top-rows",
  );
  const bottomRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-bottom-rows",
  );
  if (!gridViewport) {
    return;
  }
  const gridHeight =
    gridViewport.clientHeight -
    (topRows?.clientHeight ?? 0) -
    (bottomRows?.clientHeight ?? 0);
  // get the rendered rows
  const renderedRowCount = params.api.getDisplayedRowCount();
  if (renderedRowCount === 0) {
    return;
  }
  // if the rendered rows * min height is greater than available height, just set the height
  // to the min and let the scrollbar do its thing
  if (renderedRowCount * minRowHeight >= gridHeight) {
    if (currentRowHeight !== minRowHeight) {
      currentRowHeight = minRowHeight;
      params.api.resetRowHeights();
    }
  } else {
    // set the height of the row to the grid height / number of rows available
    currentRowHeight = Math.floor(gridHeight / renderedRowCount);
    params.api.resetRowHeights();
  }
};

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :rowData="rowData"
      :getRowHeight="getRowHeight"
      @first-data-rendered="onFirstDataRendered"
      @grid-size-changed="onGridSizeChanged"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete", width: 140 },
      { field: "age", width: 60 },
      { field: "country", width: 130 },
      { field: "year", width: 70 },
      { field: "date", width: 110 },
      { field: "sport", width: 110 },
      { field: "gold", flex: 1 },
      { field: "silver", flex: 1 },
      { field: "bronze", flex: 1 },
      { field: "total", flex: 1 },
    ]);
    const rowData = ref<any[] | null>(getData());
    const getRowHeight = ref<GetRowHeight>((params: RowHeightParams) => {
      return currentRowHeight;
    });

    function onFirstDataRendered(params: FirstDataRenderedEvent) {
      updateRowHeight(params);
    }
    function onGridSizeChanged(params: GridSizeChangedEvent) {
      updateRowHeight(params);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      minRowHeight = params.api.getSizesForCurrentTheme().rowHeight;
      currentRowHeight = minRowHeight;
    };

    return {
      gridApi,
      columnDefs,
      rowData,
      getRowHeight,
      onGridReady,
      onFirstDataRendered,
      onGridSizeChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Dynamic vertical resizing](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example2/vue3/)

## Auto Height Layout

Depending on your scenario, you may wish for the grid to auto-size it's height to the number of rows displayed inside the grid. This is useful if you have relatively few rows and don't want empty space between the last row and the bottom of the grid.

To allow the grid to auto-size its height to fit rows, set grid property `domLayout='autoHeight'`.

When `domLayout='autoHeight'` then your application **should not** set height on the grid div, as the div should be allowed flow naturally to fit the grid contents. When auto height is off then your application **should** set height on the grid div, as the grid will fill the div you provide it.

> **Warning**
>
> There is no default maximum height, which means that the grid will render all rows. When using the Server-Side Row Model, this will mean loading the entire data set. For large grids (eg >1,000 rows) the draw time of the grid will be slow, or for very large grids, your application can freeze. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display on one web page. For this reason, if showing large amounts of data, set a [max height](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grid-size/#minimum-and-maximum-height-with-auto-height) to limit the number of rows rendered.

The example below demonstrates the autoHeight feature. Notice the following:

- As you set different numbers of rows into the grid, the grid will resize its height to just fit the rows.
- As the grid height exceeds the height of the browser, you will need to use the browser vertical scroll to view data (or the iFrames scroll if you are looking at the example embedded below).
- The height will also adjust as you filter, to add and remove rows.
- If you have pinned rows, the grid will size to accommodate the pinned rows.
- Vertical scrolling will not happen, however horizontal scrolling, including pinned columns, will work as normal.
- You can switch the grid into and out of auto-height mode by calling `api.setGridOption('domLayout', layout)` or by changing the bound `domLayout` property.

> **Note**
>
> The following example is best viewed in a new tab, so it is obvious that there are no scroll bars. When viewed inline below, the scroll bars shown are for the containing iframe, not the grid.

#### Auto Height

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DomLayoutType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  PinnedRowModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  NumberFilterModule,
]);

function createRow(index: number) {
  const makes = ["Toyota", "Ford", "BMW", "Phantom", "Porsche"];
  return {
    id: "D" + (1000 + index),
    make: makes[Math.floor(window.agRandom() * makes.length)],
    price: Math.floor(window.agRandom() * 100000),
    val1: Math.floor(window.agRandom() * 1000),
    val2: Math.floor(window.agRandom() * 1000),
    val3: Math.floor(window.agRandom() * 1000),
    val4: Math.floor(window.agRandom() * 1000),
    val5: Math.floor(window.agRandom() * 1000),
    val6: Math.floor(window.agRandom() * 1000),
    val7: Math.floor(window.agRandom() * 1000),
    val8: Math.floor(window.agRandom() * 1000),
    val9: Math.floor(window.agRandom() * 1000),
    val10: Math.floor(window.agRandom() * 1000),
  };
}

function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push(createRow(i));
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-header">
      <div>
        <button v-on:click="updateRowData(0)">0 Rows</button>
        <button v-on:click="updateRowData(5)">5 Rows</button>
        <button v-on:click="updateRowData(50)">50 Rows</button>
      </div>
      <div>
        <button v-on:click="setDomLayoutAutoHeight()">Auto Height</button>
        <button v-on:click="setDomLayoutNormal()">Fixed Height</button>
      </div>
      <div>
        <input name="pinned-rows" type="checkbox" id="floating-rows" v-on:click="toggleFloatingRows()">
          <label for="pinned-rows"> Pinned Rows </label>
        </div>
        <div>Row Count = <span id="currentRowCount"></span></div>
      </div>
      <ag-grid-vue
        id="myGrid"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"
        :domLayout="domLayout"
        :popupParent="popupParent"></ag-grid-vue>
        <div style="border: 10px solid #eee; padding: 10px; margin-top: 20px">
          <p style="text-align: center">
            This text is under the grid and should move up and down as the height of the grid changes.
          </p>
        </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<(ColDef | ColGroupDef)[]>([
      {
        headerName: "Core",
        children: [
          { headerName: "ID", field: "id" },
          { field: "make" },
          { field: "price", filter: "agNumberColumnFilter" },
        ],
      },
      {
        headerName: "Extra",
        children: [
          { field: "val1", filter: "agNumberColumnFilter" },
          { field: "val2", filter: "agNumberColumnFilter" },
          { field: "val3", filter: "agNumberColumnFilter" },
          { field: "val4", filter: "agNumberColumnFilter" },
          { field: "val5", filter: "agNumberColumnFilter" },
          { field: "val6", filter: "agNumberColumnFilter" },
          { field: "val7", filter: "agNumberColumnFilter" },
          { field: "val8", filter: "agNumberColumnFilter" },
          { field: "val9", filter: "agNumberColumnFilter" },
          { field: "val10", filter: "agNumberColumnFilter" },
        ],
      },
    ]);
    const defaultColDef = ref<ColDef>({
      enableRowGroup: true,
      enableValue: true,
      filter: true,
    });
    const rowData = ref<any[] | null>(getData(5));
    const domLayout = ref<DomLayoutType>("autoHeight");
    const popupParent = ref<HTMLElement | null>(document.body);

    function updateRowData(rowCount: number) {
      gridApi.value!.setGridOption("rowData", getData(rowCount));
      document.querySelector("#currentRowCount")!.textContent = `${rowCount}`;
    }
    function toggleFloatingRows() {
      const show = (
        document.getElementById("floating-rows") as HTMLInputElement
      ).checked;
      if (show) {
        gridApi.value!.setGridOption("pinnedTopRowData", [
          createRow(999),
          createRow(998),
        ]);
        gridApi.value!.setGridOption("pinnedBottomRowData", [
          createRow(997),
          createRow(996),
        ]);
      } else {
        gridApi.value!.setGridOption("pinnedTopRowData", undefined);
        gridApi.value!.setGridOption("pinnedBottomRowData", undefined);
      }
    }
    function setDomLayoutAutoHeight() {
      gridApi.value!.setGridOption("domLayout", "autoHeight");
      // auto height will get the grid to fill the height of the contents,
      // so the grid div should have no height set, the height is dynamic.
      (document.querySelector<HTMLElement>("#myGrid")! as any).style.height =
        "";
    }
    function setDomLayoutNormal() {
      gridApi.value!.setGridOption("domLayout", "normal");
      // when auto height is off, the grid has a fixed height and provides
      // scrollbars if the data does not fit into it.
      (document.querySelector<HTMLElement>("#myGrid")! as any)!.style.height =
        "400px";
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;

      document.querySelector("#currentRowCount")!.textContent = "5";
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      domLayout,
      popupParent,
      onGridReady,
      updateRowData,
      toggleFloatingRows,
      setDomLayoutAutoHeight,
      setDomLayoutNormal,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height/vue3/)

### Minimum and Maximum Height with Auto Height

You can constrain the height of the grid body - the scrolling rows, excluding headers and pinned rows. By default the minimum height is 150px (because a zero-height grid looks weird) and there is no maximum height. This can be customised using two [theme parameters](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/theming-parameters/):

```js
const myTheme = themeQuartz.withParams({
    autoHeightMinBodyHeight: 0,
    autoHeightMaxBodyHeight: 400,
});
```

Once the height of the available rows exceeds the maximum height, the grid stops growing and scrolls instead, using [virtualisation](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/dom-virtualisation/) to ensure that large datasets are rendered efficiently.

You can see the effect of minimum and maximum heights with different numbers of rows in the following example:

#### Max Height with Auto Height

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DomLayoutType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

let rowCount = 5;

let minBodyHeight = 100;

let maxBodyHeight: number | "none" = 250;

function buildTheme() {
  return themeQuartz.withParams({
    autoHeightMinBodyHeight: minBodyHeight,
    autoHeightMaxBodyHeight: maxBodyHeight,
  });
}

const makes = ["Toyota", "Ford", "BMW", "Porsche", "Audi"];

function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push({
      id: "D" + (1000 + i),
      make: makes[i % makes.length],
      model: "Model " + (i + 1),
      price: 20000 + i * 750,
    });
  }
  return rowData;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="test-header">
      <div>
        <label for="row-count">Rows</label>
        <input id="row-count" type="number" min="0" max="50" value="5" v-on:input="onRowCountChanged()">
        </div>
        <div>
          <label for="min-body-height">autoHeightMinBodyHeight</label>
          <input id="min-body-height" type="number" min="0" max="600" step="10" value="100" v-on:input="onMinBodyHeightChanged()">
          </div>
          <div>
            <label for="max-body-height">autoHeightMaxBodyHeight (blank for none)</label>
            <input id="max-body-height" type="number" min="0" max="600" step="10" value="250" v-on:input="onMaxBodyHeightChanged()">
            </div>
          </div>
          <ag-grid-vue
            id="myGrid"
            @grid-ready="onGridReady"
            :theme="theme"
            :domLayout="domLayout"
            :columnDefs="columnDefs"
            :defaultColDef="defaultColDef"
            :rowData="rowData"></ag-grid-vue>
            <div class="under-grid">
              <p>This text sits under the grid and moves up and down as the grid resizes to fit its rows.</p>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const theme = ref<Theme | "legacy">(buildTheme());
    const domLayout = ref<DomLayoutType>("autoHeight");
    const columnDefs = ref<ColDef[]>([
      { field: "id" },
      { field: "make" },
      { field: "model" },
      { field: "price" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const rowData = ref<any[] | null>(getData(rowCount));

    function onRowCountChanged() {
      rowCount = Number(
        (document.getElementById("row-count") as HTMLInputElement).value,
      );
      gridApi.value.setGridOption("rowData", getData(rowCount));
    }
    function onMinBodyHeightChanged() {
      minBodyHeight = Number(
        (document.getElementById("min-body-height") as HTMLInputElement).value,
      );
      gridApi.value.setGridOption("theme", buildTheme());
    }
    function onMaxBodyHeightChanged() {
      const value = (
        document.getElementById("max-body-height") as HTMLInputElement
      ).value;
      // an empty control means no maximum, the default for auto height
      maxBodyHeight = value === "" ? "none" : Number(value);
      gridApi.value.setGridOption("theme", buildTheme());
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      theme,
      domLayout,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onRowCountChanged,
      onMinBodyHeightChanged,
      onMaxBodyHeightChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Max Height with Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height-max/vue3/)

## Print Layout

For details on displaying the grid in a printer friendly layout see the [Print Layout](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/printing/) page.


---
product: "AG Grid"
title: "Grid Layout"
description: "Format the grid layout for your React Table. Change grid width/height, assign a DOM layout value, format dynamic resizing."
framework: react
version: "36.2.0"
related:
    - title: "Design System"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/ag-grid-design-system/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Layout

Set the width, height and scrolling behaviour of the grid.

```html
<!-- set width using percentages -->
<AgGridReact style={{ width: '100%', height: '100%' }} />

<!-- OR set width using fixed pixels -->
<AgGridReact style={{ width: 500, height: 200 }} />
```

> **Warning**
>
> If using % for your height, then make sure the container you are putting the grid into also has height specified, as the browser will fit the div according to a percentage of the parent's height, and if the parent has no height, then this % will always be zero.
>
> If your grid is not the size you think it should be then put a border on the grid's div and see if that's the size you want (the grid will fill this div). If it is not the size you want, then you have a CSS layout issue in your application.

## DOM Layout

There are three DOM Layout values the grid can have 'normal', 'autoHeight' and 'print'. They are used as follows:

- **normal**: This is the default if nothing is specified. The grid fits the width and height of the div you provide and scrolls in both directions.
- **autoHeight**: The grid's height adjusts to fit the number of rows, with optional minimum and maximum height.
- **print**: No scroll bars are used and the grid renders all rows and columns. This layout is explained in [Printing](https://www.ag-grid.com/archive/36.2.0/react-data-grid/printing/).

## Normal Layout

If the width and / or height change after the grid is initialised, the grid will automatically resize to fill the new area.

The example below shows setting the grid size and then changing it as the user selects the buttons.

#### Width & Height

```tsx
'use client';
import { useFetchJson } from './useFetchJson';
import React, { StrictMode, useMemo, useRef, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);

  const columnDefs = useMemo<ColDef[]>(
    () => [
      { field: "athlete", width: 150 },
      { field: "age", width: 90 },
      { field: "country", width: 150 },
      { field: "year", width: 90 },
      { field: "date", width: 150 },
      { field: "sport", width: 150 },
      { field: "gold", width: 100 },
      { field: "silver", width: 100 },
      { field: "bronze", width: 100 },
      { field: "total", width: 100 },
    ],
    [],
  );
  const [style, setStyle] = useState({
    height: "100%",
    width: "100%",
  });

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const fillLarge = () => {
    setWidthAndHeight("100%", "100%");
  };

  const fillMedium = () => {
    setWidthAndHeight("60%", "60%");
  };

  const fillExact = () => {
    setWidthAndHeight("400px", "400px");
  };

  const setWidthAndHeight = (width: string, height: string) => {
    setStyle({
      width,
      height,
    });
  };

  return (
    <AgGridProvider modules={modules}>
      <div className="example-wrapper">
        <div style={{ marginBottom: "5px" }}>
          <button onClick={() => fillLarge()}>Fill 100%</button>
          <button onClick={() => fillMedium()}>Fill 60%</button>
          <button onClick={() => fillExact()}>Exactly 400 x 400 pixels</button>
        </div>
        <div className="grid-wrapper">
          <div style={style}>
            <AgGridReact
              ref={gridRef}
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Width & Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/width-and-height/reactFunctionalTs/)

### Dynamic Resizing without Horizontal Scroll

Sometimes you want to have columns that don't fit in the current viewport to simply be hidden altogether with no horizontal scrollbar.

To achieve this determine the width of the grid and work out how many columns could fit in that space, hiding any that don't fit, constantly updating based on the `gridSizeChanged` event firing, like the next example shows.

This example is best seen when opened in a new tab - then change the horizontal size of the browser and watch as columns hide/show based on the current grid size.

#### Dynamic horizontal resizing without scroll

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  ColumnAutoSizeModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridSizeChangedEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ColumnAutoSizeModule,
  ColumnApiModule,
  ClientSideRowModelModule,
];

let sizeToFitTimer: number | undefined;

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", minWidth: 150 },
    { field: "age", minWidth: 70, maxWidth: 90 },
    { field: "country", minWidth: 130 },
    { field: "year", minWidth: 70, maxWidth: 90 },
    { field: "date", minWidth: 120 },
    { field: "sport", minWidth: 120 },
    { field: "gold", minWidth: 80 },
    { field: "silver", minWidth: 80 },
    { field: "bronze", minWidth: 80 },
    { field: "total", minWidth: 80 },
  ]);

  const { data, loading } = useFetchJson<IOlympicData>(
    "https://www.ag-grid.com/example-assets/olympic-winners.json",
  );

  const onGridSizeChanged = useCallback(
    (params: GridSizeChangedEvent) => {
      // get the current grids width
      const gridWidth =
        document.querySelector(".ag-grid-viewport")!.clientWidth;
      // keep track of which columns to hide/show
      const columnsToShow = [];
      const columnsToHide = [];
      // iterate over all columns (visible or not) in their current displayed order,
      // so that hiding follows the order the user sees rather than the column definition order
      let totalColsWidth = 0;
      const allColumns = params.api.getAllGridColumns();
      for (let i = 0, len = allColumns.length; i < len; i++) {
        const column = allColumns[i];
        totalColsWidth += column.getMinWidth();
        if (totalColsWidth > gridWidth) {
          columnsToHide.push(column.getColId());
        } else {
          columnsToShow.push(column.getColId());
        }
      }
      // show/hide columns based on current grid width
      params.api.setColumnsVisible(columnsToShow, true);
      params.api.setColumnsVisible(columnsToHide, false);
      // wait until columns stopped moving and fill out
      // any available space to ensure there are no gaps. The timer is cleared on every size change so
      // only the latest one re-fits, and the grid can be destroyed before it fires - hence the guard.
      window.clearTimeout(sizeToFitTimer);
      sizeToFitTimer = window.setTimeout(() => {
        if (params.api.isDestroyed()) {
          return;
        }
        params.api.sizeColumnsToFit();
      }, 10);
    },
    [window, sizeToFitTimer],
  );

  const onFirstDataRendered = useCallback((params: FirstDataRenderedEvent) => {
    params.api.sizeColumnsToFit();
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div id="grid-wrapper" style={{ width: "100%", height: "100%" }}>
          <div style={gridStyle}>
            <AgGridReact<IOlympicData>
              rowData={data}
              loading={loading}
              columnDefs={columnDefs}
              onGridSizeChanged={onGridSizeChanged}
              onFirstDataRendered={onFirstDataRendered}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Dynamic horizontal resizing without scroll](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example1/reactFunctionalTs/)

### Dynamic Vertical Resizing

Sometimes the grid is taller than the rows it contains. You can dynamically set the row heights to fill the available height as the following example shows:

#### Dynamic vertical resizing

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GetRowHeight,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridSizeChangedEvent,
  ModuleRegistry,
  RenderApiModule,
  RowApiModule,
  RowHeightParams,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  RenderApiModule,
  RowApiModule,
  ClientSideRowModelModule,
];

let minRowHeight = 25;

let currentRowHeight: number;

const updateRowHeight = (params: { api: GridApi }) => {
  // get the height of the grid body - this excludes the height of the headers
  const gridViewport = document.querySelector<HTMLElement>(".ag-grid-viewport");
  const topRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-top-rows",
  );
  const bottomRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-bottom-rows",
  );
  if (!gridViewport) {
    return;
  }
  const gridHeight =
    gridViewport.clientHeight -
    (topRows?.clientHeight ?? 0) -
    (bottomRows?.clientHeight ?? 0);
  // get the rendered rows
  const renderedRowCount = params.api.getDisplayedRowCount();
  if (renderedRowCount === 0) {
    return;
  }
  // if the rendered rows * min height is greater than available height, just set the height
  // to the min and let the scrollbar do its thing
  if (renderedRowCount * minRowHeight >= gridHeight) {
    if (currentRowHeight !== minRowHeight) {
      currentRowHeight = minRowHeight;
      params.api.resetRowHeights();
    }
  } else {
    // set the height of the row to the grid height / number of rows available
    currentRowHeight = Math.floor(gridHeight / renderedRowCount);
    params.api.resetRowHeights();
  }
};

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete", width: 140 },
    { field: "age", width: 60 },
    { field: "country", width: 130 },
    { field: "year", width: 70 },
    { field: "date", width: 110 },
    { field: "sport", width: 110 },
    { field: "gold", flex: 1 },
    { field: "silver", flex: 1 },
    { field: "bronze", flex: 1 },
    { field: "total", flex: 1 },
  ]);
  const getRowHeight = useCallback((params: RowHeightParams) => {
    return currentRowHeight;
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    minRowHeight = params.api.getSizesForCurrentTheme().rowHeight;
    currentRowHeight = minRowHeight;
  }, []);

  const onFirstDataRendered = useCallback(
    (params: FirstDataRenderedEvent) => {
      updateRowHeight(params);
    },
    [updateRowHeight],
  );

  const onGridSizeChanged = useCallback(
    (params: GridSizeChangedEvent) => {
      updateRowHeight(params);
    },
    [updateRowHeight],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            getRowHeight={getRowHeight}
            onGridReady={onGridReady}
            onFirstDataRendered={onFirstDataRendered}
            onGridSizeChanged={onGridSizeChanged}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Dynamic vertical resizing](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example2/reactFunctionalTs/)

## Auto Height Layout

Depending on your scenario, you may wish for the grid to auto-size it's height to the number of rows displayed inside the grid. This is useful if you have relatively few rows and don't want empty space between the last row and the bottom of the grid.

To allow the grid to auto-size its height to fit rows, set grid property `domLayout='autoHeight'`.

When `domLayout='autoHeight'` then your application **should not** set height on the grid div, as the div should be allowed flow naturally to fit the grid contents. When auto height is off then your application **should** set height on the grid div, as the grid will fill the div you provide it.

> **Warning**
>
> There is no default maximum height, which means that the grid will render all rows. When using the Server-Side Row Model, this will mean loading the entire data set. For large grids (eg >1,000 rows) the draw time of the grid will be slow, or for very large grids, your application can freeze. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display on one web page. For this reason, if showing large amounts of data, set a [max height](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grid-size/#minimum-and-maximum-height-with-auto-height) to limit the number of rows rendered.

The example below demonstrates the autoHeight feature. Notice the following:

- As you set different numbers of rows into the grid, the grid will resize its height to just fit the rows.
- As the grid height exceeds the height of the browser, you will need to use the browser vertical scroll to view data (or the iFrames scroll if you are looking at the example embedded below).
- The height will also adjust as you filter, to add and remove rows.
- If you have pinned rows, the grid will size to accommodate the pinned rows.
- Vertical scrolling will not happen, however horizontal scrolling, including pinned columns, will work as normal.
- You can switch the grid into and out of auto-height mode by calling `api.setGridOption('domLayout', layout)` or by changing the bound `domLayout` property.

> **Note**
>
> The following example is best viewed in a new tab, so it is obvious that there are no scroll bars. When viewed inline below, the scroll bars shown are for the containing iframe, not the grid.

#### Auto Height

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DomLayoutType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  PinnedRowModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  TextFilterModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  NumberFilterModule,
];

function createRow(index: number) {
  const makes = ["Toyota", "Ford", "BMW", "Phantom", "Porsche"];
  return {
    id: "D" + (1000 + index),
    make: makes[Math.floor(window.agRandom() * makes.length)],
    price: Math.floor(window.agRandom() * 100000),
    val1: Math.floor(window.agRandom() * 1000),
    val2: Math.floor(window.agRandom() * 1000),
    val3: Math.floor(window.agRandom() * 1000),
    val4: Math.floor(window.agRandom() * 1000),
    val5: Math.floor(window.agRandom() * 1000),
    val6: Math.floor(window.agRandom() * 1000),
    val7: Math.floor(window.agRandom() * 1000),
    val8: Math.floor(window.agRandom() * 1000),
    val9: Math.floor(window.agRandom() * 1000),
    val10: Math.floor(window.agRandom() * 1000),
  };
}

function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push(createRow(i));
  }
  return rowData;
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData(5));
  const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
    {
      headerName: "Core",
      children: [
        { headerName: "ID", field: "id" },
        { field: "make" },
        { field: "price", filter: "agNumberColumnFilter" },
      ],
    },
    {
      headerName: "Extra",
      children: [
        { field: "val1", filter: "agNumberColumnFilter" },
        { field: "val2", filter: "agNumberColumnFilter" },
        { field: "val3", filter: "agNumberColumnFilter" },
        { field: "val4", filter: "agNumberColumnFilter" },
        { field: "val5", filter: "agNumberColumnFilter" },
        { field: "val6", filter: "agNumberColumnFilter" },
        { field: "val7", filter: "agNumberColumnFilter" },
        { field: "val8", filter: "agNumberColumnFilter" },
        { field: "val9", filter: "agNumberColumnFilter" },
        { field: "val10", filter: "agNumberColumnFilter" },
      ],
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      enableRowGroup: true,
      enableValue: true,
      filter: true,
    };
  }, []);
  const popupParent = useMemo<HTMLElement | null>(() => {
    return document.body;
  }, []);

  const onGridReady = useCallback((params: GridReadyEvent) => {
    document.querySelector("#currentRowCount")!.textContent = "5";
  }, []);

  const updateRowData = useCallback((rowCount: number) => {
    setRowData(getData(rowCount));
    document.querySelector("#currentRowCount")!.textContent = `${rowCount}`;
  }, []);

  const toggleFloatingRows = useCallback(() => {
    const show = (document.getElementById("floating-rows") as HTMLInputElement)
      .checked;
    if (show) {
      gridRef.current!.api.setGridOption("pinnedTopRowData", [
        createRow(999),
        createRow(998),
      ]);
      gridRef.current!.api.setGridOption("pinnedBottomRowData", [
        createRow(997),
        createRow(996),
      ]);
    } else {
      gridRef.current!.api.setGridOption("pinnedTopRowData", undefined);
      gridRef.current!.api.setGridOption("pinnedBottomRowData", undefined);
    }
  }, []);

  const setDomLayoutAutoHeight = useCallback(() => {
    gridRef.current!.api.setGridOption("domLayout", "autoHeight");
    // auto height will get the grid to fill the height of the contents,
    // so the grid div should have no height set, the height is dynamic.
    (document.querySelector<HTMLElement>("#myGrid")! as any).style.height = "";
  }, []);

  const setDomLayoutNormal = useCallback(() => {
    gridRef.current!.api.setGridOption("domLayout", "normal");
    // when auto height is off, the grid has a fixed height and provides
    // scrollbars if the data does not fit into it.
    (document.querySelector<HTMLElement>("#myGrid")! as any)!.style.height =
      "400px";
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div>
        <div className="test-header">
          <div>
            <button onClick={() => updateRowData(0)}>0 Rows</button>
            <button onClick={() => updateRowData(5)}>5 Rows</button>
            <button onClick={() => updateRowData(50)}>50 Rows</button>
          </div>
          <div>
            <button onClick={setDomLayoutAutoHeight}>Auto Height</button>
            <button onClick={setDomLayoutNormal}>Fixed Height</button>
          </div>
          <div>
            <input
              name="pinned-rows"
              type="checkbox"
              id="floating-rows"
              onClick={toggleFloatingRows}
            />
            <label htmlFor="pinned-rows"> Pinned Rows </label>
          </div>
          <div>
            Row Count = <span id="currentRowCount"></span>
          </div>
        </div>

        <div id="myGrid" style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            domLayout={"autoHeight"}
            popupParent={popupParent}
            onGridReady={onGridReady}
          />
        </div>

        <div
          style={{
            border: "10px solid #eee",
            padding: "10px",
            marginTop: "20px",
          }}
        >
          <p style={{ textAlign: "center" }}>
            This text is under the grid and should move up and down as the
            height of the grid changes.
          </p>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height/reactFunctionalTs/)

### Minimum and Maximum Height with Auto Height

You can constrain the height of the grid body - the scrolling rows, excluding headers and pinned rows. By default the minimum height is 150px (because a zero-height grid looks weird) and there is no maximum height. This can be customised using two [theme parameters](https://www.ag-grid.com/archive/36.2.0/react-data-grid/theming-parameters/):

```js
const myTheme = themeQuartz.withParams({
    autoHeightMinBodyHeight: 0,
    autoHeightMaxBodyHeight: 400,
});
```

Once the height of the available rows exceeds the maximum height, the grid stops growing and scrolls instead, using [virtualisation](https://www.ag-grid.com/archive/36.2.0/react-data-grid/dom-virtualisation/) to ensure that large datasets are rendered efficiently.

You can see the effect of minimum and maximum heights with different numbers of rows in the following example:

#### Max Height with Auto Height

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DomLayoutType,
  GridOptions,
  ModuleRegistry,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [ClientSideRowModelModule];

let rowCount = 5;

let minBodyHeight = 100;

let maxBodyHeight: number | "none" = 250;

function buildTheme() {
  return themeQuartz.withParams({
    autoHeightMinBodyHeight: minBodyHeight,
    autoHeightMaxBodyHeight: maxBodyHeight,
  });
}

const makes = ["Toyota", "Ford", "BMW", "Porsche", "Audi"];

function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push({
      id: "D" + (1000 + i),
      make: makes[i % makes.length],
      model: "Model " + (i + 1),
      price: 20000 + i * 750,
    });
  }
  return rowData;
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData(rowCount));
  const theme = useMemo<Theme | "legacy">(() => {
    return buildTheme();
  }, []);
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "id" },
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
    };
  }, []);

  const onRowCountChanged = useCallback(() => {
    rowCount = Number(
      (document.getElementById("row-count") as HTMLInputElement).value,
    );
    setRowData(getData(rowCount));
  }, [rowCount]);

  const onMinBodyHeightChanged = useCallback(() => {
    minBodyHeight = Number(
      (document.getElementById("min-body-height") as HTMLInputElement).value,
    );
    gridRef.current!.api.setGridOption("theme", buildTheme());
  }, []);

  const onMaxBodyHeightChanged = useCallback(() => {
    const value = (
      document.getElementById("max-body-height") as HTMLInputElement
    ).value;
    // an empty control means no maximum, the default for auto height
    maxBodyHeight = value === "" ? "none" : Number(value);
    gridRef.current!.api.setGridOption("theme", buildTheme());
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div>
        <div className="test-header">
          <div>
            <label htmlFor="row-count">Rows</label>
            <input
              id="row-count"
              type="number"
              min="0"
              max="50"
              defaultValue="5"
              onInput={onRowCountChanged}
            />
          </div>
          <div>
            <label htmlFor="min-body-height">autoHeightMinBodyHeight</label>
            <input
              id="min-body-height"
              type="number"
              min="0"
              max="600"
              step="10"
              defaultValue="100"
              onInput={onMinBodyHeightChanged}
            />
          </div>
          <div>
            <label htmlFor="max-body-height">
              autoHeightMaxBodyHeight (blank for none)
            </label>
            <input
              id="max-body-height"
              type="number"
              min="0"
              max="600"
              step="10"
              defaultValue="250"
              onInput={onMaxBodyHeightChanged}
            />
          </div>
        </div>

        <div id="myGrid" style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            theme={theme}
            domLayout={"autoHeight"}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
          />
        </div>

        <div className="under-grid">
          <p>
            This text sits under the grid and moves up and down as the grid
            resizes to fit its rows.
          </p>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Max Height with Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height-max/reactFunctionalTs/)

## Print Layout

For details on displaying the grid in a printer friendly layout see the [Print Layout](https://www.ag-grid.com/archive/36.2.0/react-data-grid/printing/) page.


---
product: "AG Grid"
title: "Grid Layout"
description: "Format the grid layout for your Angular Table. Change grid width/height, assign a DOM layout value, format dynamic resizing."
framework: angular
version: "36.2.0"
related:
    - title: "Design System"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/ag-grid-design-system/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Grid Layout

Set the width, height and scrolling behaviour of the grid.

```html
<!-- set width using percentages -->
<ag-grid-angular style="width: 100%; height: 100%;" />

<!-- OR set width using fixed pixels -->
<ag-grid-angular style="width: 500px; height: 200px" />
```

> **Warning**
>
> If using % for your height, then make sure the container you are putting the grid into also has height specified, as the browser will fit the div according to a percentage of the parent's height, and if the parent has no height, then this % will always be zero.
>
> If your grid is not the size you think it should be then put a border on the grid's div and see if that's the size you want (the grid will fill this div). If it is not the size you want, then you have a CSS layout issue in your application.

## DOM Layout

There are three DOM Layout values the grid can have 'normal', 'autoHeight' and 'print'. They are used as follows:

- **normal**: This is the default if nothing is specified. The grid fits the width and height of the div you provide and scrolls in both directions.
- **autoHeight**: The grid's height adjusts to fit the number of rows, with optional minimum and maximum height.
- **print**: No scroll bars are used and the grid renders all rows and columns. This layout is explained in [Printing](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/printing/).

## Normal Layout

If the width and / or height change after the grid is initialised, the grid will automatically resize to fill the new area.

The example below shows setting the grid size and then changing it as the user selects the buttons.

#### Width & Height

```ts
import { NgStyle } from "@angular/common";
import { HttpClient } from "@angular/common/http";
import type { OnInit } from "@angular/core";
import { Component, ViewChild } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type { ColDef } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

@Component({
  standalone: true,
  imports: [AgGridAngular, NgStyle],
  selector: "my-app",
  template: `
    <div style="height: 100%; display: flex; flex-direction: column;">
      <div style="margin-bottom: 5px;">
        <button (click)="fillLarge()">Fill 100%</button>
        <button (click)="fillMedium()">Fill 60%</button>
        <button (click)="fillExact()">Exactly 400 x 400 pixels</button>
      </div>
      <div [ngStyle]="style">
        <ag-grid-angular
          style="width: 100%; height:100%;"
          #agGrid
          [rowData]="rowData"
          [columnDefs]="columnDefs"
        />
      </div>
    </div>
  `,
})
export class AppComponent implements OnInit {
  @ViewChild("agGrid") agGrid!: AgGridAngular<IOlympicData>;

  public style: any = {
    width: "100%",
    height: "100%",
    flex: "1 1 auto",
  };

  public columnDefs: ColDef[] = [
    { field: "athlete", width: 150 },
    { field: "age", width: 90 },
    { field: "country", width: 150 },
    { field: "year", width: 90 },
    { field: "date", width: 150 },
    { field: "sport", width: 150 },
    { field: "gold", width: 100 },
    { field: "silver", width: 100 },
    { field: "bronze", width: 100 },
    { field: "total", width: 100 },
  ];
  public rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  ngOnInit() {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => {
        this.rowData = data;
      });
  }

  fillLarge() {
    this.setWidthAndHeight("100%", "100%");
  }

  fillMedium() {
    this.setWidthAndHeight("60%", "60%");
  }

  fillExact() {
    this.setWidthAndHeight("400px", "400px");
  }

  setWidthAndHeight(width: string, height: string) {
    this.style = {
      width: width,
      height: height,
    };
  }
}
```

[Live example: Width & Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/width-and-height/angular/)

### Dynamic Resizing without Horizontal Scroll

Sometimes you want to have columns that don't fit in the current viewport to simply be hidden altogether with no horizontal scrollbar.

To achieve this determine the width of the grid and work out how many columns could fit in that space, hiding any that don't fit, constantly updating based on the `gridSizeChanged` event firing, like the next example shows.

This example is best seen when opened in a new tab - then change the horizontal size of the browser and watch as columns hide/show based on the current grid size.

#### Dynamic horizontal resizing without scroll

```ts
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColumnApiModule,
  ColumnAutoSizeModule,
  FirstDataRenderedEvent,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridSizeChangedEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ColumnAutoSizeModule,
  ColumnApiModule,
  ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div id="grid-wrapper" style="width: 100%; height: 100%">
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      (gridSizeChanged)="onGridSizeChanged($event)"
      (firstDataRendered)="onFirstDataRendered($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", minWidth: 150 },
    { field: "age", minWidth: 70, maxWidth: 90 },
    { field: "country", minWidth: 130 },
    { field: "year", minWidth: 70, maxWidth: 90 },
    { field: "date", minWidth: 120 },
    { field: "sport", minWidth: 120 },
    { field: "gold", minWidth: 80 },
    { field: "silver", minWidth: 80 },
    { field: "bronze", minWidth: 80 },
    { field: "total", minWidth: 80 },
  ];
  rowData!: IOlympicData[];

  constructor(private http: HttpClient) {}

  onGridSizeChanged(params: GridSizeChangedEvent) {
    // get the current grids width
    const gridWidth = document.querySelector(".ag-grid-viewport")!.clientWidth;
    // keep track of which columns to hide/show
    const columnsToShow = [];
    const columnsToHide = [];
    // iterate over all columns (visible or not) in their current displayed order,
    // so that hiding follows the order the user sees rather than the column definition order
    let totalColsWidth = 0;
    const allColumns = params.api.getAllGridColumns();
    for (let i = 0, len = allColumns.length; i < len; i++) {
      const column = allColumns[i];
      totalColsWidth += column.getMinWidth();
      if (totalColsWidth > gridWidth) {
        columnsToHide.push(column.getColId());
      } else {
        columnsToShow.push(column.getColId());
      }
    }
    // show/hide columns based on current grid width
    params.api.setColumnsVisible(columnsToShow, true);
    params.api.setColumnsVisible(columnsToHide, false);
    // wait until columns stopped moving and fill out
    // any available space to ensure there are no gaps. The timer is cleared on every size change so
    // only the latest one re-fits, and the grid can be destroyed before it fires - hence the guard.
    window.clearTimeout(sizeToFitTimer);
    sizeToFitTimer = window.setTimeout(() => {
      if (params.api.isDestroyed()) {
        return;
      }
      params.api.sizeColumnsToFit();
    }, 10);
  }

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    params.api.sizeColumnsToFit();
  }

  onGridReady(params: GridReadyEvent<IOlympicData>) {
    this.http
      .get<
        IOlympicData[]
      >("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}

let sizeToFitTimer: number | undefined;
```

[Live example: Dynamic horizontal resizing without scroll](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example1/angular/)

### Dynamic Vertical Resizing

Sometimes the grid is taller than the rows it contains. You can dynamically set the row heights to fill the available height as the following example shows:

#### Dynamic vertical resizing

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  FirstDataRenderedEvent,
  GetRowHeight,
  GridApi,
  GridOptions,
  GridReadyEvent,
  GridSizeChangedEvent,
  ModuleRegistry,
  RenderApiModule,
  RowApiModule,
  RowHeightParams,
  enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RenderApiModule,
  RowApiModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [getRowHeight]="getRowHeight"
    (firstDataRendered)="onFirstDataRendered($event)"
    (gridSizeChanged)="onGridSizeChanged($event)"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete", width: 140 },
    { field: "age", width: 60 },
    { field: "country", width: 130 },
    { field: "year", width: 70 },
    { field: "date", width: 110 },
    { field: "sport", width: 110 },
    { field: "gold", flex: 1 },
    { field: "silver", flex: 1 },
    { field: "bronze", flex: 1 },
    { field: "total", flex: 1 },
  ];
  rowData: any[] | null = getData();
  getRowHeight: GetRowHeight = (params: RowHeightParams) => {
    return currentRowHeight;
  };

  onFirstDataRendered(params: FirstDataRenderedEvent) {
    updateRowHeight(params);
  }

  onGridSizeChanged(params: GridSizeChangedEvent) {
    updateRowHeight(params);
  }

  onGridReady(params: GridReadyEvent) {
    minRowHeight = params.api.getSizesForCurrentTheme().rowHeight;
    currentRowHeight = minRowHeight;
  }
}

let minRowHeight = 25;
let currentRowHeight: number;
const updateRowHeight = (params: { api: GridApi }) => {
  // get the height of the grid body - this excludes the height of the headers
  const gridViewport = document.querySelector<HTMLElement>(".ag-grid-viewport");
  const topRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-top-rows",
  );
  const bottomRows = document.querySelector<HTMLElement>(
    ".ag-grid-pinned-bottom-rows",
  );
  if (!gridViewport) {
    return;
  }
  const gridHeight =
    gridViewport.clientHeight -
    (topRows?.clientHeight ?? 0) -
    (bottomRows?.clientHeight ?? 0);
  // get the rendered rows
  const renderedRowCount = params.api.getDisplayedRowCount();
  if (renderedRowCount === 0) {
    return;
  }
  // if the rendered rows * min height is greater than available height, just set the height
  // to the min and let the scrollbar do its thing
  if (renderedRowCount * minRowHeight >= gridHeight) {
    if (currentRowHeight !== minRowHeight) {
      currentRowHeight = minRowHeight;
      params.api.resetRowHeights();
    }
  } else {
    // set the height of the row to the grid height / number of rows available
    currentRowHeight = Math.floor(gridHeight / renderedRowCount);
    params.api.resetRowHeights();
  }
};
```

[Live example: Dynamic vertical resizing](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/example2/angular/)

## Auto Height Layout

Depending on your scenario, you may wish for the grid to auto-size it's height to the number of rows displayed inside the grid. This is useful if you have relatively few rows and don't want empty space between the last row and the bottom of the grid.

To allow the grid to auto-size its height to fit rows, set grid property `domLayout='autoHeight'`.

When `domLayout='autoHeight'` then your application **should not** set height on the grid div, as the div should be allowed flow naturally to fit the grid contents. When auto height is off then your application **should** set height on the grid div, as the grid will fill the div you provide it.

> **Warning**
>
> There is no default maximum height, which means that the grid will render all rows. When using the Server-Side Row Model, this will mean loading the entire data set. For large grids (eg >1,000 rows) the draw time of the grid will be slow, or for very large grids, your application can freeze. This is not a problem with the grid, it is a limitation on browsers on how much data they can easily display on one web page. For this reason, if showing large amounts of data, set a [max height](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grid-size/#minimum-and-maximum-height-with-auto-height) to limit the number of rows rendered.

The example below demonstrates the autoHeight feature. Notice the following:

- As you set different numbers of rows into the grid, the grid will resize its height to just fit the rows.
- As the grid height exceeds the height of the browser, you will need to use the browser vertical scroll to view data (or the iFrames scroll if you are looking at the example embedded below).
- The height will also adjust as you filter, to add and remove rows.
- If you have pinned rows, the grid will size to accommodate the pinned rows.
- Vertical scrolling will not happen, however horizontal scrolling, including pinned columns, will work as normal.
- You can switch the grid into and out of auto-height mode by calling `api.setGridOption('domLayout', layout)` or by changing the bound `domLayout` property.

> **Note**
>
> The following example is best viewed in a new tab, so it is obvious that there are no scroll bars. When viewed inline below, the scroll bars shown are for the containing iframe, not the grid.

#### Auto Height

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DomLayoutType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  NumberFilterModule,
  PinnedRowModule,
  TextFilterModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RowGroupingModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  TextFilterModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RowGroupingModule,
  NumberFilterModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-header">
      <div>
        <button (click)="updateRowData(0)">0 Rows</button>
        <button (click)="updateRowData(5)">5 Rows</button>
        <button (click)="updateRowData(50)">50 Rows</button>
      </div>
      <div>
        <button (click)="setDomLayoutAutoHeight()">Auto Height</button>
        <button (click)="setDomLayoutNormal()">Fixed Height</button>
      </div>
      <div>
        <input
          name="pinned-rows"
          type="checkbox"
          id="floating-rows"
          (click)="toggleFloatingRows()"
        />
        <label for="pinned-rows"> Pinned Rows </label>
      </div>
      <div>Row Count = <span id="currentRowCount"></span></div>
    </div>

    <ag-grid-angular
      id="myGrid"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      [domLayout]="domLayout"
      [popupParent]="popupParent"
      (gridReady)="onGridReady($event)"
    />

    <div style="border: 10px solid #eee; padding: 10px; margin-top: 20px">
      <p style="text-align: center">
        This text is under the grid and should move up and down as the height of
        the grid changes.
      </p>
    </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: (ColDef | ColGroupDef)[] = [
    {
      headerName: "Core",
      children: [
        { headerName: "ID", field: "id" },
        { field: "make" },
        { field: "price", filter: "agNumberColumnFilter" },
      ],
    },
    {
      headerName: "Extra",
      children: [
        { field: "val1", filter: "agNumberColumnFilter" },
        { field: "val2", filter: "agNumberColumnFilter" },
        { field: "val3", filter: "agNumberColumnFilter" },
        { field: "val4", filter: "agNumberColumnFilter" },
        { field: "val5", filter: "agNumberColumnFilter" },
        { field: "val6", filter: "agNumberColumnFilter" },
        { field: "val7", filter: "agNumberColumnFilter" },
        { field: "val8", filter: "agNumberColumnFilter" },
        { field: "val9", filter: "agNumberColumnFilter" },
        { field: "val10", filter: "agNumberColumnFilter" },
      ],
    },
  ];
  defaultColDef: ColDef = {
    enableRowGroup: true,
    enableValue: true,
    filter: true,
  };
  rowData: any[] | null = getData(5);
  domLayout: DomLayoutType = "autoHeight";
  popupParent: HTMLElement | null = document.body;

  updateRowData(rowCount: number) {
    this.gridApi.setGridOption("rowData", getData(rowCount));
    document.querySelector("#currentRowCount")!.textContent = `${rowCount}`;
  }

  toggleFloatingRows() {
    const show = (document.getElementById("floating-rows") as HTMLInputElement)
      .checked;
    if (show) {
      this.gridApi.setGridOption("pinnedTopRowData", [
        createRow(999),
        createRow(998),
      ]);
      this.gridApi.setGridOption("pinnedBottomRowData", [
        createRow(997),
        createRow(996),
      ]);
    } else {
      this.gridApi.setGridOption("pinnedTopRowData", undefined);
      this.gridApi.setGridOption("pinnedBottomRowData", undefined);
    }
  }

  setDomLayoutAutoHeight() {
    this.gridApi.setGridOption("domLayout", "autoHeight");
    // auto height will get the grid to fill the height of the contents,
    // so the grid div should have no height set, the height is dynamic.
    (document.querySelector<HTMLElement>("#myGrid")! as any).style.height = "";
  }

  setDomLayoutNormal() {
    this.gridApi.setGridOption("domLayout", "normal");
    // when auto height is off, the grid has a fixed height and provides
    // scrollbars if the data does not fit into it.
    (document.querySelector<HTMLElement>("#myGrid")! as any)!.style.height =
      "400px";
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    document.querySelector("#currentRowCount")!.textContent = "5";
  }
}

function createRow(index: number) {
  const makes = ["Toyota", "Ford", "BMW", "Phantom", "Porsche"];
  return {
    id: "D" + (1000 + index),
    make: makes[Math.floor(window.agRandom() * makes.length)],
    price: Math.floor(window.agRandom() * 100000),
    val1: Math.floor(window.agRandom() * 1000),
    val2: Math.floor(window.agRandom() * 1000),
    val3: Math.floor(window.agRandom() * 1000),
    val4: Math.floor(window.agRandom() * 1000),
    val5: Math.floor(window.agRandom() * 1000),
    val6: Math.floor(window.agRandom() * 1000),
    val7: Math.floor(window.agRandom() * 1000),
    val8: Math.floor(window.agRandom() * 1000),
    val9: Math.floor(window.agRandom() * 1000),
    val10: Math.floor(window.agRandom() * 1000),
  };
}
function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push(createRow(i));
  }
  return rowData;
}
```

[Live example: Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height/angular/)

### Minimum and Maximum Height with Auto Height

You can constrain the height of the grid body - the scrolling rows, excluding headers and pinned rows. By default the minimum height is 150px (because a zero-height grid looks weird) and there is no maximum height. This can be customised using two [theme parameters](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/theming-parameters/):

```js
const myTheme = themeQuartz.withParams({
    autoHeightMinBodyHeight: 0,
    autoHeightMaxBodyHeight: 400,
});
```

Once the height of the available rows exceeds the maximum height, the grid stops growing and scrolls instead, using [virtualisation](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/dom-virtualisation/) to ensure that large datasets are rendered efficiently.

You can see the effect of minimum and maximum heights with different numbers of rows in the following example:

#### Max Height with Auto Height

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  DomLayoutType,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  Theme,
  enableDevValidations,
  themeQuartz,
} from "ag-grid-community";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([ClientSideRowModelModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="test-header">
      <div>
        <label for="row-count">Rows</label>
        <input
          id="row-count"
          type="number"
          min="0"
          max="50"
          value="5"
          (input)="onRowCountChanged()"
        />
      </div>
      <div>
        <label for="min-body-height">autoHeightMinBodyHeight</label>
        <input
          id="min-body-height"
          type="number"
          min="0"
          max="600"
          step="10"
          value="100"
          (input)="onMinBodyHeightChanged()"
        />
      </div>
      <div>
        <label for="max-body-height"
          >autoHeightMaxBodyHeight (blank for none)</label
        >
        <input
          id="max-body-height"
          type="number"
          min="0"
          max="600"
          step="10"
          value="250"
          (input)="onMaxBodyHeightChanged()"
        />
      </div>
    </div>

    <ag-grid-angular
      id="myGrid"
      [theme]="theme"
      [domLayout]="domLayout"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [rowData]="rowData"
      (gridReady)="onGridReady($event)"
    />

    <div class="under-grid">
      <p>
        This text sits under the grid and moves up and down as the grid resizes
        to fit its rows.
      </p>
    </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  theme: Theme | "legacy" = buildTheme();
  domLayout: DomLayoutType = "autoHeight";
  columnDefs: ColDef[] = [
    { field: "id" },
    { field: "make" },
    { field: "model" },
    { field: "price" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  rowData: any[] | null = getData(rowCount);

  onRowCountChanged() {
    rowCount = Number(
      (document.getElementById("row-count") as HTMLInputElement).value,
    );
    this.gridApi.setGridOption("rowData", getData(rowCount));
  }

  onMinBodyHeightChanged() {
    minBodyHeight = Number(
      (document.getElementById("min-body-height") as HTMLInputElement).value,
    );
    this.gridApi.setGridOption("theme", buildTheme());
  }

  onMaxBodyHeightChanged() {
    const value = (
      document.getElementById("max-body-height") as HTMLInputElement
    ).value;
    // an empty control means no maximum, the default for auto height
    maxBodyHeight = value === "" ? "none" : Number(value);
    this.gridApi.setGridOption("theme", buildTheme());
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

let rowCount = 5;
let minBodyHeight = 100;
let maxBodyHeight: number | "none" = 250;
function buildTheme() {
  return themeQuartz.withParams({
    autoHeightMinBodyHeight: minBodyHeight,
    autoHeightMaxBodyHeight: maxBodyHeight,
  });
}
const makes = ["Toyota", "Ford", "BMW", "Porsche", "Audi"];
function getData(count: number) {
  const rowData = [];
  for (let i = 0; i < count; i++) {
    rowData.push({
      id: "D" + (1000 + i),
      make: makes[i % makes.length],
      model: "Model " + (i + 1),
      price: 20000 + i * 750,
    });
  }
  return rowData;
}
```

[Live example: Max Height with Auto Height](https://www.ag-grid.com/archive/36.2.0/examples/grid-size/auto-height-max/angular/)

## Print Layout

For details on displaying the grid in a printer friendly layout see the [Print Layout](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/printing/) page.
